prog::testinit("ShiftOp",  423.4 ):
package("sumtools"):
mytest(Dom::ShiftOperators):

mytest := proc(m) 
begin 
  eval(hold(prog::testfunc)(_concat(args()))): 
  print(Unquoted, _concat("*** Testing: ", args())): 
end_proc:

//////////////////////////////////////////////////////////////////////////////
mytest("constructors"):

prog::test(domtype((R := Dom::ShiftOperators())), DOM_DOMAIN):

// creating elements
mytest("creating elements"):

prog::test(R::order((L1 := R(S^2-(x^2+x-1/x)*S+x^3-x))), 2):
prog::test(R::order((L2 := R(S-4*x^4-x^2+1/(x^2)))), 1):
prog::test(R::order((L3 := R(R(S^3 - (1/x^6)*S^2-(x^2+x-1/x)*S+x^3-x)))), 3):
prog::test(R::order((L4 := R((x+2)*S-x))), 1):

prog::test(R::order((L6 := R((x+2)*S+x))), 1):
prog::test(R::order((L7 := R(3*S^2+(x+1)*S+x))), 2):
prog::test(R::order((L8 := R((3)*S^2 + ((- x^2 - 2*x - 1)/(x + 3))*S + ((x^3 + x^2)/(x^2 + 5*x + 6))))), 2):
prog::test(R::order((L9 := R((x + 10)*S + ((-1)*x)))), 1):
prog::test(R::order((L10 := R(S^2+x*S+1))), 2):
prog::test(R::order((L11 := R(S+x^2+x-1))), 1): 
prog::test(R::order((L12 := R(S^2 + (- x - 1)*S + (x - 1)))), 2): 
prog::test(R::order((L13 := R(S^2 + ((-1)*x^2)*S + 5))), 2):
prog::test(R::order((L14 := R((x^2 + x + 1)*S^2 + (- x - 1)*S + (x - 1)))), 2):
prog::test(R::order((L15 := R((x^3 - x + 1)*S^2 + ((-1)*x^2)*S + (x^2 - 1)))), 2):

// basic arithmetic
mytest("basic arithmetic"):

prog::test(R::order((L := L1*L2)), 3):
prog::test(traperror((Sol := R::rightdivide(L,L2))), 0):
prog::test(iszero(Sol[1]-L1) and iszero(Sol[2]), TRUE):
prog::test(traperror((Sol := R::leftdivide(L,L1))), 0):
prog::test(iszero(Sol[1]-L2) and iszero(Sol[2]), TRUE):
prog::test(R::gcrd(L1*L3, L2*L3), L3):
//prog::test(R::order((LCLM := R::lclm(L1*L3, L2*L3))), 6):
//prog::test(iszero(op(R::rightdivide(LCLM, L3), 2)), TRUE):
prog::test(R::order((L100 := R::symprod(L7, L6))), 2):
prog::test(R::order((L101 := R::lcm(L8, L9))), 3):
prog::test(R::order((L102 := L10*L11)), 3):
prog::test(R::order((L103 := L12*L13)), 4):
prog::test(R::order((L104 := R::adjoint(L103))), 4):
prog::test(R::order((L105 := L14*L15)), 4):

// polynomial solutions
mytest("polynomial solutions of order 1"):
for i from 1 to 10 do
  p := polylib::randpoly(Degree=i):
  L := R(expr(p)*S-polylib::shift(p,1)):
  prog::test(nops((Sol := R::polysols(L))), 1): 
  prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
end_for:

mytest("polynomial solutions of higher order"):
for ord from 2 to 10 do
  mytest("polynomial solutions of order ", ord):
  p := polylib::randpoly(Degree=5):
  L0 := R(expr(p)*S-polylib::shift(p,1)):
  L := L0;
  for j from 1 to ord do
    q := expr(polylib::randpoly(Degree=2)):
    prog::test(R::order((L := L + R(q*S)*L)), j+1):
    prog::test(nops((Sol := R::polysols(L))), 1): 
    prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
  end_for;
end_for:

// rational solutions
mytest("rational solutions of given operators"):

prog::test(nops((Sol := R::ratsols(L4))), 1): 
prog::test(map(Sol, (y)->(simplify(L4(y)))), {0}):
prog::test(nops((Sol := R::ratsols(L100))), 1): 
v := op(indets(op(Sol,1)) minus {x}):
prog::test(subs(expr(op(Sol, 1)), v=Y),  1/x^2/(x + 1)*(Y*x^3 - 9*Y*x^2 + 17*Y*x)):
prog::test(simplify(L100(op(Sol))), 0):
prog::test(nops((Sol := R::ratsols(L101))), 1): 
prog::test(simplify(L101(op(Sol))), 0):

mytest("rational solutions of random operators"):
for ord from 2 to 10 do
  mytest("rational solutions of order ", ord):
  p := polylib::randpoly(Degree=5):
  r := polylib::randpoly(Degree=5):
  L0 := R(expr(p)/expr(r)*S-expr(polylib::shift(p,1))/expr(polylib::shift(r,1))):
  L := L0;
  for j from 1 to ord do
    q := expr(polylib::randpoly(Degree=2)):
    prog::test(R::order((L := L + R(q*S)*L)), j+1):
    Sol := "MUFF";
    prog::test(nops((Sol := R::ratsols(L))), 1): 
    if Sol="MUFF" then
      print(L);
      error("muff");
    end_if;
    prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
  end_for;
end_for:

// L := SO((x^2 + x)*S^2 + (- 2*x^2 - 20*x)*S + (x^2 + 19*x + 90))
// Aus CluHoe05
// L := SO(x^4*S^5 + (5*x^5 - 12*x^3 - 3*x)*S^4 - (x^6 + x + 7)*S^3 - (140*x^3 + 1)*S^2 + 10*x^5*S - 8*x^3):

// factorization degree 1
mytest("factorization degree 1"):

prog::test(nops((Sol := R::factorHoeij(L102))), 1):
prog::test(iszero(op(Sol) - L11), TRUE):
prog::test(nops((Sol := R::factorHoeij(L101))), 1):
prog::test(iszero(R::rightdivide(L101, op(Sol,1))[2]), TRUE):


// factorization degree 2
mytest("factorization degree 2"):

prog::test(nops((Sol := R::rightFactorOrder(L103,2))), 1):
prog::test(iszero(op(Sol) - L13), TRUE):
prog::test(nops((Sol := R::rightFactorOrder(L104,2))), 1):
prog::test(iszero(op(Sol) - R::adjoint(L12)), TRUE):
//prog::test(nops((Sol := R::factorOrder2(L105))), 1):
//prog::test(R::order(op(Sol)), 2):
//prog::test(iszero(R::rightdivide(L105, op(Sol))[2]), TRUE):
/*
mytest("Operators over Expression-Field"):

prog::test(domtype((R := Dom::ShiftOperators(x,S,Dom::ExpressionField()))), DOM_DOMAIN):

mytest("EF basic arithmetic"):
prog::test(R::order((L1 := R(S^2+(3*b+x)*S+(x^2-1)))), 2):
prog::test(R::order((L2 := R(S+a))), 1):
prog::test(((L := L1*L2)), R(S^3 + (x + (a + 3*b))*S^2 + (x^2 + a*x + (3*a*b - 1))*S + (a*x^2 - a))):
prog::test(iszero(R::rightdivide(L,L2)[2]), TRUE);

mytest("EF rational solutions"):
prog::test(R::order((LL := R(S^3 + ((-1/a)*x - 1/a*(a + 3*b))*S^2 + (1/a^2*x^2 + 1/a*x + 1/a^2*(3*a*b - 1))*S + ((-1/a^2)*x^2 + 1/a^2)))), 3):
prog::test(nops((Sol := R::ratsols(LL))), 1):
prog::test(map(Sol, (y)->(simplify(LL(y)))), {0}):

mytest("EF factor of order 1"):
prog::test(nops((Sol := R::factorHoeij(L))), 1);
prog::test(iszero(R::rightdivide(L,op(Sol))[2]), TRUE);

mytest("Practical Examples"):

F :=  a*(n+2*z)*(x+4)*T^4 +
      (-2*a*x - 4*z - 2*z^3 + 2*n^2 - 6*a + 6*z^2 - 3*n*z^2 - n^2*z + 7*n*z - 2*n)*T^3 +
      (2*a*x - 5*a*n + 2*z + 4*z^3 - n^2 - 4*z*a*x - 10*z*a + n^3 + 4*a - 6*z^2 + 6*n*z^2 + 4*n^2*z - 4*n*z - 2*a*x*n)*T^2 +
      (2*a*x + 2*z - 2*z^3 + 4*a - 3*n*z^2 - n^2*z + n*z)*T +
      a*(n-2+2*z)*(x+1):
F2 := subs(F, z=(r-x-a-2)):
R := Dom::ShiftOperators(n,T,Dom::ExpressionField());
*/
prog::testexit():
